/* -*- C -*- */
%option nounput noinput noyywrap
%{
  /* Prologue C. */
  #include <inttypes.h>
  #include "parse-calc.h"
  #define YY_USER_ACTION                         \
    yylloc->last_column += yyleng;
  #define STEP()                                \
  do {                                          \
    yylloc->first_line = yylloc->last_line;     \
    yylloc->first_column = yylloc->last_column; \
  } while (0)
%}

%%
%{
  STEP();
%}

"+"    return TOK_PLUS;
"-"    return TOK_MINUS;
"*"    return TOK_STAR;
"/"    return TOK_SLASH;
"("    return TOK_LPAREN;
")"    return TOK_RPAREN;
[0-9]+ yylval->intval = strtol(yytext, 0, 10); return TOK_INT;

"\n"   yylloc->last_column = 0; yylloc->last_line += 1; STEP(); return TOK_EOL;
[ \t]+ STEP(); continue;

.      fprintf (stderr, "invalid character: %c\n", *yytext); ++nerrs;
%%
/* Epilogue. */
